'
' Serial buffer replacement for Hserin/Hrsin commands Demonstration program
'
' For 18F devices only.
' The code can be simulated using ISIS and the PIC18_ALCD_VHB.DSN circuit.
'
    Device = 18F452
    Xtal = 20
    Optimiser_Level = 3                 ' Full optimisation
    Dead_Code_Remove = On               ' Remove redundant ASM mnemonics
'
' Setup the USART
'
    Hserial_Baud = 9600                 ' Set baud rate for USART 1
    Hserial_RCSTA = %10010000           ' Enable serial port and continuous receive
    Hserial_TXSTA = %00100000           ' Enable transmit and asynchronous mode
'
' Setup the LCD
'
    LCD_DTPin = PORTD.4                 ' Point LCD DATA lines to PORTD.4, PORTD.5, PORTD.6, and PORTD.7
    LCD_RSPin = PORTE.0                 ' Point LCD RS line to PORTE.0
    LCD_ENPin = PORTE.1                 ' Point LCD EN line to PORTE.0
    LCD_Interface = 4                   ' Set the LCD interface to 4-bit
    LCD_Lines = 2                       ' Set the amount of lines in the LCD as 2
'
' Create some variables
'
    Dim Bytein As Byte
    Dim Xpos As Byte

'------------------------------------------------------------------------------------------------------------------------------------

    Include "Buffered_Hserin.Inc"    ' Load the USART 1 interrupt handler and buffer read subroutines into memory

'------------------------------------------------------------------------------------------------------------------------------------
'
' Main program loop starts here
'
Main_Program:
    DelayMS 100                      ' Wait for the LCD to stabilise
    All_Digital = True               ' Make PORTA and PORTE digital inputs

    HRSOut "Type some characters in the terminal window\r",_
           "and they will appear on the LCD.\r",_
           "Note that no characters are missed\r",_
           "even though there is a stupidly large delay within the receiving loop.\r\r"

    Init_Usart_Interrupt             ' Initiate the USART 1 serial buffer interrupt
    Clear_Serial_Buffer              ' Clear the serial buffer and reset its pointers

    Cls                              ' Clear the LCD
    Print "Ready"
    Cursor 2,1                       ' Move to beginning of line 2 on the LCD
    Xpos = 0                         ' Reset the X position on the LCD
    While 1 = 1                      ' Create an infinite loop
        HRSIn Bytein                 ' Read data from the serial buffer
        HRSOut Bytein                ' Echo the character to the terminal
        Inc Xpos                     ' Increment the X position of the LCD
        If Xpos > 15 Then            ' Have we filled the second line of the LCD ?
            Print At 2,1,Rep " "\16  ' Yes. So Clear the second line of the LCD
            Cursor 2,1               ' Move to beginning of line 2 on the LCD
            Xpos = 0                 ' Reset the X position of the LCD
        EndIf
        DelayMS 200         ' <<< Add a stupidly large delay between serial capture >>>
        Print Bytein                 ' Display the byte received from the serial buffer
    Wend

